#!/bin/bash

#   install_base.sh - install some basic crap like vim, and configure
#   a proper FQDN, stuff like that.
#
#   DISS - Debian Install Server Scripts
#   A set of scripts to automate installation of Servers on Debian
#   (c) 2009 Emmanuel Revah - manu-at-manurevah.com
#
#   This file is part of DISS.
#
#   DISS is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   DISS is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with DISS.  If not, see <http://www.gnu.org/licenses/>.

# FIXME
#	- IP: add some regex verifications
#	- reorganise to get data and then confirm before doing

clear
source /etc/diss/diss.conf
source ${SCRIPTS}/functions.sh

THISSCRIPT=install_base.sh
THISSTATE=${BASESTATE}
installStatus

apt-get update
apt-get upgrade -y
apt-get install -y screen vim bzip2 openntpd nmap less openssh-client openssh-server

${WHIPMSG} "we shall now reconfigure locales
choose whatever you need. (i've heard
that people enjoy the UTF stuff these days)" 0 0
dpkg-reconfigure locales

# vim config
sed -i.diss-BKP -e 's/\"syntax on/syntax on/' -e 's/\"set background=dark/set background=dark/' /etc/vim/vimrc

# confirm IP addr
clear
FOUNDIP=`ifconfig |grep Bcast|cut -d ":" -f 2|cut -d " " -f 1`
echo -n "

 #############

 IP : ${FOUNDIP}

 #############

If ${FOUNDIP} is the correct IP then press enter
otherwise manually enter public IP here: "
read IP
: ${IP:="${FOUNDIP}"}

echo -n "

This machine should have a proper hostname setup, something
like : 'server.domain.tld', it should correspond to the PTR
of the IP ${IP} (or at least the public IP).

The current fully qualified domain name appears to be

FQDN =  `hostname --fqdn`

Do you wan't to change that (Y/n): "
read CHANGEFQDN


if [ "${CHANGEFQDN}" != "N" ] && [ "${CHANGEFQDN}" != "n" ]; then
	getInpute "Enter teh hostname (not FQDN) (exemple: servername):" domain
	MACHINENAME="${ANSWER}"
	getInpute "Enter domain name (exemple: domain.tld):" domain
	DOMAIN="${ANSWER}"

	FQDN="${MACHINENAME}.${DOMAIN}"
	cp /etc/hosts /etc/hosts.diss-BKP
	cp /etc/hostname /etc/hostname.diss-BKP
	echo ${MACHINENAME} > /etc/hostname
	echo "127.0.0.1       localhost
127.0.1.1	${MACHINENAME}
${IP}	${FQDN}	${MACHINENAME}

::1     ip6-localhost ip6-loopback
fe00::0 ip6-localnet
ff00::0 ip6-mcastprefix
ff02::1 ip6-allnodes
ff02::2 ip6-allrouters
ff02::3 ip6-allhosts"  > /etc/hosts
	hostname ${FQDN}

	echo "
The Fully Qualified Domaine Name appears to be : `hostname --fqdn`"
	echo "
The files /etc/hostname and /etc/hosts have been rewritten,
there are backup copies (.diss-BKP) if you need to correct or
things personalize your configurations"

else
	FQDN=`hostname --fqdn`
fi


# update status in diss.conf
sed -i "s/BASESTATE=\"not installed\"/BASESTATE=\"done\"/" ${DISSETC}diss.conf
sed -i "s/IP=/IP=\"${IP}\"/" ${DISSETC}diss.conf
sed -i "s/FQDN=/FQDN=\"${FQDN}\"/" ${DISSETC}diss.conf

echo "

Base install finished

press any key to return to DISS menu
"
read
exit
