#!/bin/bash

#   install_firewall.sh - install arno iptables firewall 
#
#   DISS - Debian Install Server Scripts
#   A set of scripts to automate installation of Servers on Debian
#   (c) 2009 Emmanuel Revah - manu-at-manurevah.com
#
#   This file is part of DISS.
#
#   DISS is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   DISS is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with DISS.  If not, see <http://www.gnu.org/licenses/>.


clear
source /etc/diss/diss.conf
source ${SCRIPTS}/functions.sh

THISSCRIPT=install_firewall.sh
THISSTATE=${FIREWALLSTATE}
installStatus

DEPENDSTATE=${BASESTATE}
DEPENDSON="install_base"
dependsOn

# install with zero/broken conf (will be fixed later)
DEBIAN_FRONTEND=noninteractive apt-get install arno-iptables-firewall -y

# find interfaced associated with the IP used
INTERFACE=`ifconfig |grep -B 2 ${IP}| grep Link|cut -d " " -f 1`

cp /etc/arno-iptables-firewall/debconf.cfg /etc/arno-iptables-firewall/debconf.cfg.diss-BKP
source /etc/arno-iptables-firewall/debconf.cfg
sed -i "s/DC_EXT_IF=\"${DC_EXT_IF}\"/DC_EXT_IF=\"${INTERFACE}\"/" /etc/arno-iptables-firewall/debconf.cfg
sed -i "s/DC_OPEN_TCP=\"${DC_OPEN_TCP}\"/DC_OPEN_TCP=\"${ARNO_OPEN_TCP}\"/" /etc/arno-iptables-firewall/debconf.cfg
sed -i "s/DC_OPEN_UDP=\"${DC_OPEN_UDP}\"/DC_OPEN_UDP=\"${ARNO_OPEN_UDP}\"/" /etc/arno-iptables-firewall/debconf.cfg
sed -i "s/DC_OPEN_ICMP=0/DC_OPEN_ICMP=\"${ARNO_OPEN_ICMP}\"/" /etc/arno-iptables-firewall/debconf.cfg

# CONFIRM !!
clear
echo -n "

 ###############
 
 IMPORTANT WARNING !!!!!
 If this goes wrong the network could be blocked and your
 ssh connection could be cut of, you should know what this
 means. Se lets check.

 => The ports ${ARNO_OPEN_TCP} will be opened on ${INTERFACE}

 If this is okay then press type 'yes' otherwise the firewall
 will NOT be restarted and you SHOULD check the file :

	/etc/arno-iptables-firewall/debconf.cfg

 Once you are happy you may restart the firewall by typing : 

	/etc/init.d/arno-iptables-firewall start

 Are we ready now ? (yes/NO) : "
read READYTOGO

if [ "${READYTOGO}" = "yes" ] || [ "${READYTOGO}" = "YES" ]; then
	/etc/init.d/arno-iptables-firewall restart
	echo "
 Firewall restarted, if you can read this message then
 it is likely that all went well \o/.

 If you need to open more ports or deactivate ping 
 use the \"reconfigure_firewall.sh\" option in the DISS
 menu."
else
	echo "
 If you need to open more ports or deactivate ping 
 use the \"reconfigure_firewall.sh\" option in the DISS
 menu."
fi

echo "
[DIRTY FIX]
 We need to \"fix\" the install of arno-iptables-firewall,
 this means answering to debconf.
 => you should answer YES to the following questions

Press enter when ready"
read
apt-get install -f

sed -i "s/FIREWALLSTATE=\"not installed\"/FIREWALLSTATE=\"done\"/" ${DISSETC}/diss.conf

echo "Everything seems to be okay. ..  :]

Press enter to go back to DISS menu"
read
exit
